<template>
  <creation-step
    :previous-step="{
      name: 'campus-campus_id-rides-id-edit',
      params: { campus_id: campus.id, id: ride.id },
    }"
    @submit="submit"
  >
    <template #form>
      <fieldset class="fields-box">
        <ec-field
          label="Lieu de départ"
          field-id="departure"
        >
          <search-poi
            id="departure"
            v-model="departure"
            :campus="campus"
          />
        </ec-field>

        <ec-field
          label="Lieu d'arrivée"
          field-id="arrival"
        >
          <search-poi
            id="arrival"
            v-model="arrival"
            :campus="campus"
          />
        </ec-field>
      </fieldset>
      <form-button
        :disabled="[departure, arrival].includes(null)"
      />
    </template>
    <template #footer>
      <poi-map
        class="map"
        :campus="campus"
        :departure="departure"
        :arrival="arrival"
        @click="selectPoi"
      />
    </template>
  </creation-step>
</template>

<script>
import creationStep from '~/components/creation-step/generic.vue';
import searchPoi from '~/components/form/search-poi.vue';
import formButton from '~/components/creation-step/form-button.vue';
import poiMap from '~/components/maps/pois.vue';
import errorsManagement from '~/helpers/mixins/errors-management';
import { generateTitles } from '~/store/context';
import init from '~/components/creation-step/mixins/init-component';

const TITLE = 'Choisissez votre départ et votre arrivée';
const SUBTITLE = 'Une fois que vous aurez confirmé votre point de récupération'
  + ' et de destination vous n\'aurez plus qu\'à lancer votre réservation.';

export default {
  components: {
    searchPoi,
    poiMap,
    creationStep,
    formButton,
  },
  mixins: [
    init(generateTitles(TITLE, SUBTITLE)),
    errorsManagement(),
  ],
  layout: 'ride-creation',
  props: {
    campus: {
      type: Object,
      default: () => ({}),
    },
    ride: {
      type: Object,
      default: () => ({}),
    },
  },
  data() {
    return {
      departure: this.ride.departure || null,
      arrival: this.ride.arrival || null,
    };
  },
  methods: {
    async submit() {
      if (this.departure && this.arrival) {
        this.handleCommonErrorsBehavior(async () => {
          await this.$api.query('rides')
            .setMask('id,status')
            .setCampus(this.campus.id)
            .edit(this.ride.id, {
              departure: this.departure,
              arrival: this.arrival,
            });

          this.$router.push({
            name: 'campus-campus_id-rides-id-confirm',
            params: { campus_id: this.campus.id, id: this.ride.id },
          });
        });
      } else {
        this.$toast.error('Veuillez renseigner votre lieu de départ et d\'arrivée');
      }
    },
    selectPoi(poi) {
      if (this.departure.id === poi.id) {
        this.departure = {
          id: null,
          label: null,
        };
      } else if (this.arrival.id === poi.id) {
        this.arrival = {
          id: null,
          label: null,
        };
      } else if (this.departure.id === null) {
        Object.assign(this.departure, poi);
      } else if (this.arrival.id === null) {
        Object.assign(this.arrival, poi);
      }
    },
  },
};
</script>

<style lang="scss" scoped>
  @import "~assets/css/head";
  fieldset {
    display: grid;
    grid-template-columns: repeat(2, 1fr);
    grid-gap: 1em;
  }

  @media screen and (max-width: 600px) {
    fieldset {
      display: flex;
      flex-direction: column;
      align-items: center;
      .field {
        width: 100%;
      }
    }
  }
</style>
